/*---------------------------------------------------------------------------------
	$Id: simplesound.c,v 1.2 2005/09/17 02:47:56 wntrmute Exp $

	Simple Sound Demo

	- Dave Murphy (WinterMute)

	$Log: simplesound.c,v $
	Revision 1.2  2005/09/17 02:47:56  wntrmute
	added use of playSound
	
	Revision 1.1  2005/09/17 02:29:02  wntrmute
	renamed source file
	added irq support for swi
	
	Revision 1.3  2005/08/31 03:02:39  wntrmute
	updated for new stdio support
	
	Revision 1.2  2005/08/04 14:52:44  wntrmute
	*** empty log message ***
	
	Revision 1.1  2005/08/03 06:29:18  wntrmute
	added sound example
	

---------------------------------------------------------------------------------*/
#include "nds.h"
#include <nds/arm9/console.h>	//basic print funcionality
#include <nds/arm9/sound.h>		// sound functions

#include <stdio.h>


// Headers generated by bin2o rule
#include "blaster_raw.h"
#include "ion_raw.h"
#include "saberoff_raw.h"

//---------------------------------------------------------------------------------
int main(void) {
//---------------------------------------------------------------------------------

	powerON( POWER_LCD | POWER_2D_B );

	// initialise the irq dispatcher
	irqInit();
	// a vblank interrupt is needed to use swiWaitForVBlank()
	// since the dispatcher handles the flags no handler is required
	irqSet(IRQ_VBLANK, NULL);
	irqEnable(IRQ_VBLANK);

	videoSetMode(0);	//not using the main screen
	videoSetModeSub(MODE_0_2D | DISPLAY_BG0_ACTIVE);	//sub bg 0 will be used to print text
	vramSetBankC(VRAM_C_SUB_BG); 

	SUB_BG0_CR = BG_MAP_BASE(31);
	
	BG_PALETTE_SUB[255] = RGB15(31,31,31);	//by default font will be rendered with color 255
	
	//consoleInit() is a lot more flexible but this gets you up and running quick
	consoleInitDefault((u16*)SCREEN_BASE_BLOCK_SUB(31), (u16*)CHAR_BASE_BLOCK_SUB(0), 16);

	iprintf("\n\nSimple Sound Demo\n\nPress A for SaberOff\n      L for ion\n      R for blaster\n");

	// set the generic sound parameters
	setGenericSound(	11025,	/* sample rate */
						127,	/* volume */
						64,		/* panning */
						1 );	/* sound format*/

	TransferSoundData blaster = {
		blaster_raw,		/* Sample address */
		blaster_raw_size,	/* Sample length */
		11025,				/* Sample rate */
		127,				/* Volume */
		64,					/* panning */
		1 					/* format */
	};

	while(1) {

		swiWaitForVBlank();
		scanKeys();
		
		u16 keys = keysDown();
		
		if ( keys & KEY_L) playGenericSound(ion_raw, ion_raw_size);

		if ( keys & KEY_A) playGenericSound(saberoff_raw, saberoff_raw_size);

		if ( keys & KEY_R) playSound(&blaster);

	}

	return 0;
}
